"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
var child_process_1 = __importDefault(require("child_process"));
var os_1 = __importDefault(require("os"));
function spawnAsync(cmd, args) {
    return new Promise(function (resolve) {
        var proc = child_process_1.default.spawn(cmd, args);
        proc.stdout.on('data', function (data) {
            process.stdout.write(data.toString());
        });
        proc.stderr.on('data', function (data) {
            process.stderr.write(data.toString());
        });
        proc.on('exit', function (exitCode) {
            resolve(exitCode);
        });
        proc.on('error', function (err) {
            console.log("Unable to start command: ".concat(err));
            resolve(1);
        });
    });
}
function preExecRunner(preExecs) {
    return __awaiter(this, void 0, void 0, function () {
        var cmdInvoker, cmdArg, _i, preExecs_1, command, exitCode;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cmdInvoker = (os_1.default.platform() === 'win32') ? 'cmd' : 'sh';
                    cmdArg = (os_1.default.platform() === 'win32') ? '/C' : '-c';
                    _i = 0, preExecs_1 = preExecs;
                    _a.label = 1;
                case 1:
                    if (!(_i < preExecs_1.length)) return [3 /*break*/, 4];
                    command = preExecs_1[_i];
                    console.log("Executing pre-exec command: ".concat(command));
                    return [4 /*yield*/, spawnAsync(cmdInvoker, [cmdArg, command])];
                case 2:
                    exitCode = _a.sent();
                    console.log('\n');
                    if (exitCode !== 0) {
                        return [2 /*return*/, false];
                    }
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, true];
            }
        });
    });
}
function run(suite, timeoutSec) {
    return __awaiter(this, void 0, void 0, function () {
        var timeout, timeoutPromise, hasPassed;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!suite.preExec) {
                        return [2 /*return*/, true];
                    }
                    timeoutPromise = new Promise(function (resolve) {
                        timeout = setTimeout(function () {
                            console.error("Pre-Exec timed out after ".concat(timeoutSec, " seconds"));
                            resolve(false);
                        }, timeoutSec * 1000);
                    });
                    return [4 /*yield*/, Promise.race([timeoutPromise, preExecRunner(suite.preExec)])];
                case 1:
                    hasPassed = _a.sent();
                    clearTimeout(timeout);
                    return [2 /*return*/, hasPassed];
            }
        });
    });
}
exports.run = run;
exports.default = run;
//# sourceMappingURL=preExec.js.map