import { IHasNpmConfig, IHasPath, IHasSuites, Suite, NpmConfig } from './types';
export declare function getAbsolutePath(pathToDir: string): string;
export declare function shouldRecordVideo(): boolean;
export declare function loadRunConfig(cfgPath: string): IHasPath | IHasNpmConfig | IHasSuites;
export declare function getDefaultRegistry(): string;
export declare function setUpNpmConfig(userConfig: NpmConfig): Promise<void>;
export declare function installNpmDependencies(packageList: string[]): Promise<void>;
export declare function rebuildNpmDependencies(path: string): Promise<void>;
export declare function hasNodeModulesFolder(runCfg: IHasPath): boolean;
export declare function getNpmConfig(runnerConfig: IHasNpmConfig): {
    registry?: undefined;
    'strict-ssl'?: undefined;
    'package-lock'?: undefined;
} | {
    registry: string;
    'strict-ssl': boolean;
    'package-lock': boolean;
};
export declare function prepareNpmEnv(runCfg: IHasNpmConfig & IHasPath): Promise<{
    name: string;
    data: {
        install: {
            duration: number;
        };
        rebuild?: {
            duration: number;
        } | undefined;
        setup: {
            duration: number;
        };
    };
}>;
export declare function getArgs(): {
    nodeBin: string;
    runCfgPath: string;
    suiteName: string;
};
export declare function getEnv(suite: Suite): {
    [key: string]: string;
};
export declare function getSuite(runConfig: IHasSuites, suiteName: string): Suite | undefined;
export declare function renameScreenshot(specFile: string, oldFilePath: string, folderName: string, fileName: string): string;
export declare function renameAsset({ specFile, oldFilePath, resultsFolder }: {
    specFile: string;
    oldFilePath: string;
    resultsFolder: string;
}): string;
export declare function escapeXML(val: string): string;
//# sourceMappingURL=utils.d.ts.map