"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.escapeXML = exports.renameAsset = exports.renameScreenshot = exports.getSuite = exports.getEnv = exports.getArgs = exports.prepareNpmEnv = exports.getNpmConfig = exports.hasNodeModulesFolder = exports.rebuildNpmDependencies = exports.installNpmDependencies = exports.setUpNpmConfig = exports.getDefaultRegistry = exports.loadRunConfig = exports.shouldRecordVideo = exports.getAbsolutePath = void 0;
// vim: tabstop=2 shiftwidth=2 expandtab
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var lodash_1 = __importDefault(require("lodash"));
var yargs_1 = __importDefault(require("yargs/yargs"));
var npm_1 = __importDefault(require("./npm"));
var DEFAULT_REGISTRY = 'https://registry.npmjs.org';
function getAbsolutePath(pathToDir) {
    if (path_1.default.isAbsolute(pathToDir)) {
        return pathToDir;
    }
    return path_1.default.join(process.cwd(), pathToDir);
}
exports.getAbsolutePath = getAbsolutePath;
function shouldRecordVideo() {
    var isVideoRecording = process.env.SAUCE_CYPRESS_VIDEO_RECORDING;
    if (isVideoRecording === undefined) {
        return true;
    }
    var videoOption = String(isVideoRecording).toLowerCase();
    return videoOption === 'true' || videoOption === '1';
}
exports.shouldRecordVideo = shouldRecordVideo;
var runConfig;
function loadRunConfig(cfgPath) {
    if (runConfig) {
        return runConfig;
    }
    if (fs_1.default.existsSync(cfgPath)) {
        runConfig = require(cfgPath);
        return runConfig;
    }
    throw new Error("Runner config (".concat(cfgPath, ") unavailable."));
}
exports.loadRunConfig = loadRunConfig;
function getDefaultRegistry() {
    return process.env.SAUCE_NPM_CACHE || DEFAULT_REGISTRY;
}
exports.getDefaultRegistry = getDefaultRegistry;
function setUpNpmConfig(userConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var defaultConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('Preparing npm environment');
                    defaultConfig = {
                        retry: { retries: 3 },
                        json: false,
                        save: false,
                        audit: false,
                        rollback: false,
                        fund: false,
                        noproxy: 'registry.npmjs.org',
                        cafile: process.env.CA_FILE || null,
                        'package-lock': false,
                        'strict-ssl': true,
                        registry: getDefaultRegistry()
                    };
                    return [4 /*yield*/, npm_1.default.load(Object.assign({}, defaultConfig, userConfig))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.setUpNpmConfig = setUpNpmConfig;
function installNpmDependencies(packageList) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("\nInstalling packages: ".concat(packageList.join(' ')));
                    return [4 /*yield*/, npm_1.default.install.apply(npm_1.default, packageList)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.installNpmDependencies = installNpmDependencies;
function rebuildNpmDependencies(path) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("\nRebuilding packages:");
                    if (!path) return [3 /*break*/, 2];
                    return [4 /*yield*/, npm_1.default.rebuild('--prefix', path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, npm_1.default.rebuild()];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.rebuildNpmDependencies = rebuildNpmDependencies;
// Check if node_modules already exists in provided project
function hasNodeModulesFolder(runCfg) {
    var projectFolder = path_1.default.dirname(runCfg.path);
    // Docker: if sauce-runner.json is in home, node_module won't be users'
    //         but the one of the runner => Discard it.
    if (!process.env.SAUCE_VM && projectFolder === process.env.HOME) {
        return false;
    }
    // Assumption: sauce-runner.json is at the root level of project folder.
    // With this location, the presence of node_modules can be checked.
    var nodeModulePath = path_1.default.join(projectFolder, 'node_modules');
    try {
        var st = fs_1.default.statSync(nodeModulePath);
        if (st && st.isDirectory()) {
            return true;
        }
    }
    catch (e) { }
    return false;
}
exports.hasNodeModulesFolder = hasNodeModulesFolder;
function getNpmConfig(runnerConfig) {
    if (runnerConfig.npm === undefined) {
        return {};
    }
    return {
        registry: runnerConfig.npm.registry || getDefaultRegistry(),
        'strict-ssl': runnerConfig.npm.strictSSL !== false,
        // https://docs.npmjs.com/cli/v6/using-npm/config#package-lock
        // By default, `npm install $package` will install `$package` as well
        // as any dependency defined in package-lock.json that is missing from
        // node_modules.
        // Setting to false means `npm install $package` only installs `$package`
        'package-lock': runnerConfig.npm.packageLock === true
    };
}
exports.getNpmConfig = getNpmConfig;
function prepareNpmEnv(runCfg) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var data, npmMetrics, packageList, npmPackages, nodeModulesPresent, npmConfig, startTime, endTime, projectPath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { install: { duration: 0 }, setup: { duration: 0 } };
                    npmMetrics = { name: 'npm_metrics.json', data: data };
                    packageList = ((_a = runCfg === null || runCfg === void 0 ? void 0 : runCfg.npm) === null || _a === void 0 ? void 0 : _a.packages) || {};
                    npmPackages = Object.entries(packageList).map(function (_a) {
                        var pkg = _a[0], version = _a[1];
                        return "".concat(pkg, "@").concat(version);
                    });
                    nodeModulesPresent = hasNodeModulesFolder(runCfg);
                    npmConfig = getNpmConfig(runCfg);
                    startTime = (new Date()).getTime();
                    return [4 /*yield*/, setUpNpmConfig(npmConfig)];
                case 1:
                    _b.sent();
                    endTime = (new Date()).getTime();
                    npmMetrics.data.setup = { duration: endTime - startTime };
                    if (!nodeModulesPresent) return [3 /*break*/, 3];
                    console.log("Detected node_modules, running npm rebuilding.");
                    projectPath = path_1.default.dirname(runCfg.path);
                    startTime = (new Date()).getTime();
                    return [4 /*yield*/, rebuildNpmDependencies(projectPath)];
                case 2:
                    _b.sent();
                    endTime = (new Date()).getTime();
                    npmMetrics.data.rebuild = { duration: endTime - startTime };
                    _b.label = 3;
                case 3:
                    if (npmPackages.length === 0) {
                        return [2 /*return*/, npmMetrics];
                    }
                    // install npm packages
                    startTime = (new Date()).getTime();
                    return [4 /*yield*/, installNpmDependencies(npmPackages)];
                case 4:
                    _b.sent();
                    endTime = (new Date()).getTime();
                    npmMetrics.data.install = { duration: endTime - startTime };
                    return [2 /*return*/, npmMetrics];
            }
        });
    });
}
exports.prepareNpmEnv = prepareNpmEnv;
var args = null;
function getArgs() {
    if (args) {
        return args;
    }
    var argv = (0, yargs_1.default)(process.argv.slice(2))
        .command('$0', 'the default command')
        .option('runCfgPath', {
        alias: 'r',
        type: 'string',
        description: 'Path to sauce runner json',
    })
        .option('suiteName', {
        alias: 's',
        type: 'string',
        description: 'Select the suite to run'
    })
        .demandOption(['runCfgPath', 'suiteName'])
        .argv;
    var runCfgPath = argv.runCfgPath, suiteName = argv.suiteName;
    var nodeBin = process.argv[0];
    args = { nodeBin: nodeBin, runCfgPath: runCfgPath, suiteName: suiteName };
    return args;
}
exports.getArgs = getArgs;
function getEnv(suite) {
    var _a, _b;
    var env = {};
    if (lodash_1.default.isObject(suite.env)) {
        env = __assign(__assign({}, env), suite.env);
    }
    if (lodash_1.default.isObject((_a = suite.config) === null || _a === void 0 ? void 0 : _a.env)) {
        env = __assign(__assign({}, env), (_b = suite === null || suite === void 0 ? void 0 : suite.config) === null || _b === void 0 ? void 0 : _b.env);
    }
    // If the variable starts with $, pull that environment variable from the process
    for (var _i = 0, _c = lodash_1.default.toPairs(env); _i < _c.length; _i++) {
        var _d = _c[_i], name_1 = _d[0], value = _d[1];
        var expectedValue = process.env[value.substring(1)];
        if (value.startsWith('$') && expectedValue) {
            env[name_1] = expectedValue;
        }
    }
    return env;
}
exports.getEnv = getEnv;
function getSuite(runConfig, suiteName) {
    return runConfig.suites.find(function (testSuite) { return testSuite.name === suiteName; });
}
exports.getSuite = getSuite;
// renameScreenshot renames screenshot.
// nested/example.test.js/screenshot.png will be renamed to nested__example.test.js__screenshot.png
// example.test.js/screenshot.png will be renamed to example.test.js__screenshot.png
function renameScreenshot(specFile, oldFilePath, folderName, fileName) {
    var newName = path_1.default.join(folderName, specFile.replace(path_1.default.sep, '__') + '__' + fileName);
    fs_1.default.renameSync(oldFilePath, newName);
    return newName;
}
exports.renameScreenshot = renameScreenshot;
// renameAsset renames asset.
// nested/example.test.js.xml will be renamed to nested__example.test.js.xml
// example.test.js.xml will not be renamed and stay example.test.js.xml
function renameAsset(_a) {
    var specFile = _a.specFile, oldFilePath = _a.oldFilePath, resultsFolder = _a.resultsFolder;
    var splittedSpecFile = specFile.split(path_1.default.sep);
    if (splittedSpecFile.length < 2) {
        return oldFilePath;
    }
    // create new file name
    var newFile = splittedSpecFile.slice(0, splittedSpecFile.length).join('__');
    var newFilePath = path_1.default.join(resultsFolder, newFile);
    fs_1.default.renameSync(oldFilePath, newFilePath);
    return newFilePath;
}
exports.renameAsset = renameAsset;
function escapeXML(val) {
    return val.replace(/[<>&'"]/g, function (c) {
        switch (c) {
            case '<': return '&lt;';
            case '>': return '&gt;';
            case '&': return '&amp;';
            case '\'': return '&apos;';
            case '"': return '&quot;';
        }
        return c;
    });
}
exports.escapeXML = escapeXML;
//# sourceMappingURL=utils.js.map